## Requisitos
+ [ncurses](https://www.gnu.org/software/ncurses/ncurses.html): ncurses debe
  estar instalado como libreria de desarrollo. En OpenSuse el paquete se llama
  **ncurses-devel**. En Ubuntu se puede llamar **libncurses-dev** o algo
  relacionado (nótese el sufijo **dev** en ambos casos)
  Una vez instalada la biblioteca, se debe compilar el archivo con el comando
  **-lncurses**, para enlazar los objetos con la librería.

## Compilar y ejecutar
Para compilar utilizar el makefile:
> make

Y para ejecutar el programa como el jugador uno (el que crea la partida)
> ./bn

Para ejecutar el programa como el jugador dos (el que se une a la partida)
> ./bn a

## Funcionamiento
Este programa funciona utilizando la librería **ncurses**, la cual permite
manipular a voluntad la pantalla de un terminal. Con los comandos precisos, el
programador puede dividir la pantalla del terminal en cuantas subventanas
quiera. Además, el programador puede situar el cursor sobre un par de
coordenadas (y, x) en el terminal. El eje de referencia puede ser la pantalla
principal o cualesquiera de las subpantallas que haya hecho.

Al ejecutar *batalla naval*, la pantalla se subdividirá en 3: la primera
subpantalla corresponde a mi campo, la segunda al campo enemigo y la tercera
a la pantalla de comandos.

El juego lo primero que hace es preguntar por la cantidad de barcos con que se
jugara. La cantidad de barcos debe ser la misma que se coloca en los dos
jugadores (todavía no implementamos una memoria compartida para que ambos
procesos puedan ver la cantidad de barcos con que el jugador 1 escogió para jugar)

Luego comienza el juego: el jugador uno parte disparando, escogiendo la
coordenada X (una letra) y luego la Y (un número). Al dar estos datos, se
efectúa el disparo y el jugador uno sabe si acertó o no. Luego le toca al
jugador dos, que verá un disparo recibido de parte del jugador uno y luego
realizará su disparo cediendo el turno al jugador uno nuevamente. El algoritmo
se repite hasta que alguien se quede sin barcos, en ese momento esa persona
pierde y el otro gana.

### Modo DEBUG (AUTOMATICO)
Mientras realizamos el desarrollo del juego, las pruebas resultaron ser muy
tediosas, ya que había que introducir muchos datos desde el teclado para colocar
los barcos en el tablero y luego para probar la lógica de los disparos (que pasa
cuando disparo al agua o a un barco, y como se ve eso desde el otro jugador).

Por eso que con la ayuda del preprocesador, definimos una variable "DEBUG" la
cual puede poseer el valor cero o uno. Dependiendo del valor de esta variable,
uno puede compilar el programa para que funcione de forma manual (el usuario
escoge las coordenadas de sus botes y disparos) o de forma automática: se le
carga un patrón al programa, el cual tiene una serie de pasos definidos que el
computador seguirá tal cuál si fuera un humano que está jugando. Se le coloca
además al computador unos *breakpoints* en donde se le pedirá al usuario que
presione <enter> para continuar.

El modo automático es útil para depurar la aplicación y ver que el programa se
comporta de forma correcta, sin la necesidad de tener que pensar las coordenadas
que se deben ingresar para hacer estas pruebas.

### Símbolos

#### En campo propio
+ **A** Parte de uno de mis barcos
+ **0** Disparo que hizo el enemigo al agua
+ * El enemigo acertó sobre uno de mis barcos


#### En campo enemigo
+ * Disparo al agua
+ **X** Disparo acertó un objetivo enemigo

### Bugs Conocidos
+ El jugador 1 y el 2 deben ponerse de acuerdo para que el jugador 1 comience
  a disparar: Si el jugador 1 dispara antes de que el jugador 2 coloque sus
  barcos, ganará automáticamente. (no hemos implementado un semáforo que espere
  a que los dos jugadores coloquen sus barcos para permitir que el juego
  continue)
