
#ifndef CONSTANTS
#define CONSTANTS

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include <sys/types.h>
#include <errno.h>

//LIBRERIA PARA GRAFICAR
#include <ncurses.h>

//LIBRERIAS DE MEMORIA COMPARTIDA
#include <sys/ipc.h>
#include <sys/shm.h>

//CONSTANTES DE TABLERO
#define X_BOARD 2
#define Y_BOARD 2
#define X_OFFSET 30
#define Y_OFFSET 20
#define Y_INPUT Y_BOARD + Y_OFFSET
#define TAMANIO_BARCO 3
#define TAMANIO_COMANDOS 10

// CONSTANTES SOBRE DIBUJOS EN EL BARCO
#define AGUA 0
#define BARCO 1
#define FALLADO 2
#define ACERTADO 3

// CONSTANTES PARA MEMORIA COMPARTIDA
#define SHMKEY ((key_t) 9870)
#define PERMS 0666
#define BSIZE 32

// ESTRUCTURA PARA GUARDAR LOS DATOS DE LAS POSICIONES DEL TABLERO
typedef struct _buffer{
	int data;
	int size;
} BUFFER;

//BUFFERS PARA COMPARTIR DATOS
extern BUFFER *buf[100];
extern BUFFER *buf_sp[100];
extern BUFFER *buf_turno[1];

//ID's DE MEMORIA COMPARTIDA
extern int shmid[110];
extern int shmid_sp[110];
extern int shmid_turno;
#endif
